(herald "Perrig-Song Example protocol, symmetrized."
	(comment "auth failure known to them."
		 "Symmetrized to symulate (ltk a b) = (ltk b a)"))

(defprotocol ps basic 
  (defrole init_l
    (vars (my_init_id yr_resp_id name) (n1 n2 text))
    (trace
     (send (cat my_init_id n1))
     (recv (enc n1 n2 (ltk my_init_id yr_resp_id)))
     (send n2)))
  (defrole init_r
    (vars (my_init_id yr_resp_id name) (n1 n2 text))
    (trace
     (send (cat my_init_id n1))
     (recv (enc n1 n2 (ltk yr_resp_id my_init_id)))
     (send n2)))
  (defrole resp_l
    (vars (my_resp_id yr_init_id name) (n2 n1 text))
    (trace 
     (recv (cat yr_init_id n1))
     (send (enc n1 n2 (ltk yr_init_id my_resp_id)))
     (recv n2)))
    (defrole resp_r
    (vars (my_resp_id yr_init_id name) (n2 n1 text))
    (trace 
     (recv (cat yr_init_id n1))
     (send (enc n1 n2 (ltk my_resp_id yr_init_id)))
     (recv n2))))

(defskeleton ps
  (vars (a b name) (n1 text))
  (defstrand init_l 3 (my_init_id a) (yr_resp_id b) (n1 n1))
  (non-orig (ltk a b) (ltk b a))
  (uniq-orig n1)
  (comment "Initiator point-of-view"))

(defskeleton ps
  (vars (a b name) (n1 text))
  (defstrand init_r 3 (my_init_id a) (yr_resp_id b) (n1 n1))
  (non-orig (ltk a b) (ltk b a))
  (uniq-orig n1)
  (comment "Initiator point-of-view, symmetric"))
	      
     
