(herald "Simplest approx to TLS:  Send pms encrypted.")


(defmacro (hash x) 
  (enc "hash_zero" x))

(defmacro (client_key_exch pm key)
  (enc "client_version" pm key))

(defprotocol tls0 basic 
  (defrole client 
    (vars (pre_master_secret skey) (server_key akey))
    (trace 
     (send 
      (client_key_exch pre_master_secret server_key))))
  (defrole server 
    (vars (pre_master_secret skey) (server_key akey))
    (trace 
     (recv 
      (client_key_exch pre_master_secret server_key)))))

(defskeleton tls0
  (vars (pms skey) (k akey)) 
  (defstrand server 1 (pre_master_secret pms) (server_key k))
  (deflistener pms)
  (non-orig (invk k))
  (uniq-orig pms)
  (comment "Neither confidentiality nor authentication guarantees to server"))


(defskeleton tls0
  (vars (pms skey) (k akey)) 
  (defstrand client 1 (pre_master_secret pms) (server_key k))
  (deflistener pms)
  (non-orig (invk k))
  (uniq-orig pms)
  (comment "No authentication guarantees to client, but confidentiality."))



